knowledge_accounting_system.WEB/Controllers/ManagerController.cs
using knowledge_accounting_system.BLL.DTO;
using knowledge_accounting_system.BLL.Infrastructure;
using knowledge_accounting_system.BLL.Interfaces;
using knowledge_accounting_system.WEB.Models;
using Microsoft.AspNet.Identity.Owin;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using System.Web;
using System.Web.Mvc;

namespace knowledge_accounting_system.WEB.Controllers
{
    [Authorize(Roles = "manager")]
    public class ManagerController : Controller
    {
        private IUserService UserService
        {
            get
            {
                return HttpContext.GetOwinContext().GetUserManager<IUserService>();
            }
        }

        private IPostService PostService
        {
            get
            {
                return HttpContext.GetOwinContext().GetUserManager<IPostService>();
            }
        }

        private IMarkService MarkService
        {
            get
            {
                return HttpContext.GetOwinContext().GetUserManager<IMarkService>();
            }
        }

        private IUserMarkService UserMarkService
        {
            get
            {
                return HttpContext.GetOwinContext().GetUserManager<IUserMarkService>();
            }
        }

        public new async Task<ActionResult> Profile()
        {
            UserDTO user = await UserService.FindUserByNameAsync(User.Identity.Name);
            return View(user);
        }

        public ActionResult Search()
        {
            return View(MarkService.Marks);
        }

        public async Task<ActionResult> SearchResult(bool Sort, string Mark, int Score)
        {
            List<UserMarkModel> itemList = new List<UserMarkModel>();            

            foreach (var i in UserMarkService.UserMarks)
            {
                var mark = await MarkService.FindMarkByIdAsync(i.MarkId);
                var name = await UserService.FindUserByIdAsync(i.UserId);
                UserMarkModel item = new UserMarkModel 
                {
                    Mark = mark.Name,
                    Name = name.Name,
                    Score = i.Score
                };
                itemList.Add(item);
            }

            if (Mark != "Предметы")
            {
                itemList = itemList.Where(x => x.Mark == Mark).ToList();
            }

            if (Score != 0) 
            {
                itemList = itemList.Where(x => x.Score == Score).ToList();
            }

            if (Sort)
            {
                itemList = itemList.OrderBy(x => x.Name).ThenBy(x => x.Mark).ToList();
            }
            else 
            {
                itemList = itemList.OrderByDescending(x => x.Name).ThenByDescending(x => x.Mark).ToList();
            }
            
            return PartialView(itemList);
        }

        public ActionResult AddPost() 
        {
            return View(new PostAddModel());
        }

        [HttpPost]
        public async Task<ActionResult> AddPost(PostAddModel item)
        {
            if (ModelState.IsValid) 
            {
                PostDTO newItem = new PostDTO
                {
                    Name = item.Name,
                    Title = item.Title,
                    Text = item.Text,
                    Date = item.Date
                };
                var result = await PostService.AddPost(newItem);
                if (result.Succedeed)
                {
                    return RedirectToAction("Index", "Home");
                }
                return RedirectToAction("Profile");
            }
            return View(item);
        }

        public ActionResult DeletePost() 
        {
            return View(PostService.Posts);
        }

        [HttpPost]
        public async Task<ActionResult> DeletePost(int id)
        {
            var result = await PostService.DeletePost(id);
            if (result.Succedeed) 
            {
                return RedirectToAction("Index", "Home");
            }
            ModelState.AddModelError("", "Неудалось удалить пост");
            return View(PostService.Posts);
        }

        public async Task<ActionResult> Edit()
        {
            var user = await UserService.FindUserByNameAsync(User.Identity.Name);
            return View(user);
        }

        [HttpPost]
        public async Task<ActionResult> Edit(string id, string email, string password)
        {
            UserDTO user = await UserService.FindUserByIdAsync(id);
            if (user != null)
            {
                user.Email = email;
                OperationDetails validEmail = await UserService.UserValidatorAsync(user);
                if (!validEmail.Succedeed)
                {
                    ModelState.AddModelError(validEmail.Property, validEmail.Message);
                }

                OperationDetails validPass = null;
                if (password != string.Empty)
                {
                    validPass = await UserService.PasswordValidatorAsync(password);
                    if (validPass.Succedeed)
                    {
                        user.Password = UserService.HashPassword(password);
                    }
                    else
                    {
                        ModelState.AddModelError(validPass.Property, validPass.Message);
                    }
                }

                if ((validEmail.Succedeed && validPass == null) || (validEmail.Succedeed && password != string.Empty && validPass.Succedeed))
                {
                    OperationDetails result = await UserService.UserUpdateAsync(user);
                    if (result.Succedeed)
                    {
                        return RedirectToAction("Profile");
                    }
                    else
                    {
                        ModelState.AddModelError(result.Property, result.Message);
                    }
                }
            }
            else
            {
                ModelState.AddModelError("", "Пользователь не найден");
            }
            return View(user);
        }
    }
}

knowledge_accounting_system.WEB/Views/Manager/AddPost.cshtml
@model knowledge_accounting_system.WEB.Models.PostAddModel
@{
    Layout = "~/Views/Shared/_ManagerLayout.cshtml";
}
@Html.ValidationSummary()
<div class="panel panel-primary">
    <div class="form-group" style="text-align:center">
        <p class="text-primary rounded border border - light" style="padding-top:8px;padding-bottom:8px;font-size:20px;">Добавление поста</p>
    </div>
    @using (Html.BeginForm())
    {
        <div class="form-group">
            <label>Заголовок</label>
            @Html.TextBoxFor(x => x.Title, new { @class = "form-control" })
        </div>
        <div class="form-group">
            <label>Текст</label>
            @Html.TextAreaFor(x => x.Text, new { @class = "form-control", style ="height:300px" })
        </div>
        <input name="Name" type="hidden" value="@User.Identity.Name" />
        <input name="Date" type="hidden" value="@DateTime.Now" />
        <button type="submit" class="btn btn-primary">Добавить</button>
        @Html.ActionLink("Отмена", "Index", "Home", null, new { @class = "btn btn-default" })
        @Html.ActionLink("Удалить пост", "DeletePost", null, new { @class = "btn btn-primary",style="float:right"})
    }
</div>

knowledge_accounting_system.WEB/Views/Manager/DeletePost.cshtml
@using knowledge_accounting_system.BLL.DTO
@model List<PostDTO>
@{
    ViewBag.Title = "Home Page";
    if (User.IsInRole("manager"))
    {
        Layout = "~/Views/Shared/_ManagerLayout.cshtml";
    }
}

<div class="panel panel-primary">
    <div class="form-group" style="text-align:center">
        <p class="text-primary rounded border border - light" style="padding-top:8px;padding-bottom:8px;font-size:20px">Посты</p>
    </div>
    @Html.ValidationSummary(true)
    @if (Model.Count == 0)
    {
        <label>Нет постов</label>
    }
    else
    {
        foreach (var i in Model)
        {
            <div class="rounded border border" style="padding-left:20px; padding-right:20px; padding-top:10px; padding-bottom:30px; margin-bottom:10px">
                <label class="font-weight-bold" style="font-size:25px">@i.Title</label>
                <p>@i.Text</p>
                <p style="float:right">Автор: @i.Name  Дата: @i.Date.ToShortDateString()</p>
                @using (Html.BeginForm("DeletePost", "Manager", new { id = i.Id }))
                {
                    <button class="btn btn-danger btn-xs" type="submit">Удалить</button>
                }
            </div>
        }
    }
</div>

knowledge_accounting_system.WEB/Views/Manager/Edit.cshtml
@model knowledge_accounting_system.BLL.DTO.UserDTO

@{
    ViewBag.Title = "Edit";
}
@Html.ValidationSummary(false)

<div class="form-group" style="text-align:center">
    <p class="text-primary rounded border border - light" style="padding-top:8px;padding-bottom:8px;font-size:20px">Редактирование профиля</p>
</div>
<div class="form-group">
    <label>Имя</label>
    <p class="form-control">@User.Identity.Name</p>
</div>

@using (Html.BeginForm())
{
    @Html.HiddenFor(x => x.Id)
    <div class="form-group">
        <label>Email</label>
        @Html.TextBoxFor(x => x.Email, new { @class = "form-control", type="email" })
    </div>
    <div class="form-group">
        <label>Пароль</label>
        <input name="password" type="password" class="form-control" pattern="(?=.*\d)(?=.*[a-z])(?=.*[A-Z]).{6,}" />
        <p style="font-size:12px"> Пароль должен содержать 6 или более символов, которые имеют хотя бы одно число, и одну букву верхнего и нижнего регистра</p>
    </div>
    <button type="submit" class="btn btn-primary">Сохранить</button>
    @Html.ActionLink("Отмена", "Profile", null, new { @class = "btn btn-default" })
}

knowledge_accounting_system.WEB/Views/Manager/Profile.cshtml
@using knowledge_accounting_system.BLL.DTO
@model UserDTO
@{
    ViewBag.Title = "Ваш профиль";
    Layout = "~/Views/Shared/_ManagerLayout.cshtml";
}

@using (Html.BeginForm())
{
    <div class="form-group" style="text-align:center">
        <p class="text-primary rounded border border - light" style="padding-top:8px;padding-bottom:8px;font-size:20px">Ваш профиль</p>
    </div>
    <div class="form-group">
        <label>Имя</label>
        <p class="form-control">@Model.Name</p>
        <label>Email</label>
        <p class="form-control">@Model.Email</p>
    </div>
}
@Html.ActionLink("Редактировать профиль", "Edit", "Manager", null, new { @class = "btn btn-primary" })
@Html.ActionLink("Выйти", "Logout", "Account", null, new { @class = "btn btn-primary", style = "float:right" })

knowledge_accounting_system.WEB/Views/Manager/Search.cshtml
@using knowledge_accounting_system.BLL.DTO
@model IEnumerable<MarkDTO>
@{
    Layout = "~/Views/Shared/_ManagerLayout.cshtml";
    AjaxOptions ajaxOptions = new AjaxOptions
    {
        UpdateTargetId = "results"
    };
}
@Scripts.Render("~/scripts/jquery-3.0.0.min.js")
@Scripts.Render("~/scripts/jquery.unobtrusive-ajax.min.js")

@using (Ajax.BeginForm("SearchResult",ajaxOptions))
{
    <div class="d-flex">
        <select class="form-control" name="Sort">
            <option value="true">По алфавиту</option>
            <option value="false">Против алфавита</option>
        </select>
        <select class="form-control" name="Mark" style="margin-left:5px">
            <option>Предметы</option>
            @foreach (var i in Model)
            {
                <option>@i.Name</option>
            }
        </select>
        <select class="form-control" name="Score" style="margin-left:5px">
            <option value="0">Оценка</option>
            <option>1</option>
            <option>2</option>
            <option>3</option>
            <option>4</option>
            <option>5</option>
        </select>
        <button class="btn btn-primary" style="margin-left:5px">Найти</button>
    </div>
}
<div id="results"></div>

knowledge_accounting_system.WEB/Views/Manager/SearchResult.cshtml
@model List<knowledge_accounting_system.WEB.Models.UserMarkModel>
<table class="table table-striped" style="margin-top:10px">
    <tr align="center">
        <th>Имя</th>
        <th>Предмет</th>
        <th>Оценка</th>
    </tr>
    @if (Model == null)
    {
        <tr>Ничего не найдено</tr>
    }
    else
    {
        foreach (var i in Model)
        {
            <tr align="center">
                <th>@i.Name</th>
                <th>@i.Mark</th>
                <th>@i.Score/5</th>
            </tr>

        }
    }
</table>